
#object-option -Wall -Wno-return-type

#object <boxes.o>
#include <Boxes/construct.gen.h>
#include <Boxes/Basic/boxes.gen.cc>
#include <Boxes/Basic/basic.gen.cc>
#include <Boxes/Basic/rubber.gen.cc>
#include <Boxes/Basic/stretch.gen.cc>
#include <Boxes/Basic/text.gen.cc>
#include <Boxes/Composite/composite.gen.cc>
#include <Boxes/Composite/concat.gen.cc>
#include <Boxes/Composite/stack.gen.cc>
#include <Boxes/Composite/math.gen.cc>
#include <Boxes/Composite/script.gen.cc>
#include <Boxes/Composite/misc.gen.cc>
#include <Boxes/Modifier/modifier.gen.cc>
#include <Boxes/Modifier/change.gen.cc>
#include <Boxes/Graphics/graphics.gen.cc>
#code
#import string
#import construct_boxes
#import code_boxes
#import code_basic_boxes
#import code_rubber_boxes
#import code_stretch_boxes
#import code_text_boxes
#import code_composite_boxes
#import code_concat_boxes
#import code_stack_boxes
#import code_math_boxes
#import code_script_boxes
#import code_misc_boxes
#import code_modifier_boxes
#import code_change_boxes
#import code_graphics_boxes
#endobject

#object <env.o>
#include <Env/env_default.gen.cc>
#include <Env/env_exec.gen.cc>
#include <Env/env_semantics.gen.cc>
#include <Env/env.gen.cc>
#code
#import code_env_default
#import code_env_exec
#import code_env_semantics
#import code_env
#endobject

#object <concater.o>
#include <Concat/concater.gen.cc>
#include <Concat/concat_text.gen.cc>
#include <Concat/concat_math.gen.cc>
#include <Concat/concat_macro.gen.cc>
#include <Concat/concat_inactive.gen.cc>
#include <Concat/concat_active.gen.cc>
#include <Concat/concat_post.gen.cc>
#code
#import code_concater
#import code_concat_text
#import code_concat_math
#import code_concat_macro
#import code_concat_inactive
#import code_concat_active
#import code_concat_post
#endobject

#object <tabeler.o>
#include <Table/table.gen.cc>
#include <Table/cell.gen.cc>
#code
#import code_table
#import code_cell
#endobject

#object <stacker.o>
#include <Format/line_item.gen.cc>
#include <Line/line_breaker.gen.cc>
#include <Line/lazy_paragraph.gen.cc>
#include <Line/lazy_vstream.gen.cc>
#include <Line/lazy_typeset.gen.cc>
#include <Stack/stacker.gen.cc>
#code
#import code_line_item
#import code_line_breaker
#import code_lazy_paragraph
#import code_lazy_vstream
#import code_lazy_typeset
#import code_stacker
#endobject

#object <formatter.o>
#include <Format/formatter.gen.cc>
#include <Format/format.gen.cc>
#code
#import code_formatter
#import code_format
#endobject

#object <pager.o>
#include <Format/page_item.gen.cc>
#include <Page/vpenalty.gen.h>
#include <Page/skeleton.gen.h>
#include <Page/page_breaker.gen.cc>
#include <Page/page_breaker.gen.cc>
#include <Page/pager.gen.cc>
#include <Page/make_pages.gen.cc>
#code
#import code_page_item
#import code_vpenalty
#import code_skeleton
#import code_page_breaker
#import code_pager
#import code_make_pages
#endobject

#object <bridge.o>
#include <Bridge/bridge_default.gen.cc>
#include <Bridge/bridge_with.gen.cc>
#include <Bridge/bridge_expand.gen.cc>
#include <Bridge/bridge_argument.gen.cc>
#include <Bridge/bridge_apply.gen.cc>
#include <Bridge/bridge_include.gen.cc>
#include <Bridge/bridge_surround.gen.cc>
#include <Bridge/bridge_document.gen.cc>
#include <Bridge/bridge_formatting.gen.cc>
#include <Bridge/bridge.gen.cc>
#include <Bridge/typesetter.gen.cc>
#code
#import code_bridge_default
#import code_bridge_with
#import code_bridge_expand
#import code_bridge_argument
#import code_bridge_apply
#import code_bridge_include
#import code_bridge_surround
#import code_bridge_document
#import code_bridge_formatting
#import code_bridge
#import code_typesetter
#endobject

#library <libtypeset>
#option -lm +X-Window
#uses <basic>
#uses <resource>
#uses <window>
#object <boxes.o>
#object <env.o>
#object <concater.o>
#object <tabeler.o>
#object <stacker.o>
#object <formatter.o>
#object <pager.o>
#object <bridge.o>
#endlibrary
